# PaymentRatesGraphWindow Struct Reference

Inheritance diagram for PaymentRatesGraphWindow:

## Public Member Functions
| PaymentRatesGraphWindow (const WindowDesc *desc, WindowNumber window_number)
virtual void | UpdateWidgetSize (int widget, Dimension *size, const Dimension &padding, Dimension *fill, Dimension *resize)
| Update size and resize step of a widget in the window.
virtual void | DrawWidget (const Rect &r, int widget) const
| Draw the contents of a nested widget.
virtual void | OnClick (Point pt, int widget, int click_count)
| A click with the left mouse button has been made on the window.
virtual void | OnTick ()
| Called once per (game) tick.
virtual void | OnInvalidateData (int data)
| Some data on this window has become invalid.
virtual void | OnHundredthTick ()
| Called once every 100 (game) ticks.

## Detailed Description

Definition at line 819 of file graph_gui.cpp.

## Member Function Documentation

virtual void PaymentRatesGraphWindow::DrawWidget | ( | const Rect & | r,
|  | int | widget |
| ) |  |  | const`[inline, virtual]`

Draw the contents of a nested widget.

Parameters:

  | r | Rectangle occupied by the widget.
  | widget | Number of the widget to draw.

Note:
  This method may not change any state, it may only use drawing functions.

Reimplemented from BaseGraphWindow.

Definition at line 858 of file graph_gui.cpp.

References _dynlang, DrawString(), CargoSpec::Get(), GfxFillRect(), Window::IsWidgetLowered(), CargoSpec::name, SetDParam(), TD_RTL, DynamicLanguages::text_dir, and WD_FRAMERECT_LEFT.

virtual void PaymentRatesGraphWindow::OnClick | ( | Point | pt,
|  | int | widget,
|  | int | click_count |
| ) |  |  | `[inline, virtual]`

A click with the left mouse button has been made on the window.

Parameters:

  | pt | the point inside the window that has been clicked.
  | widget | the clicked widget.
  | click_count | Number of fast consecutive clicks at same position

Reimplemented from BaseGraphWindow.

Definition at line 884 of file graph_gui.cpp.

References BaseGraphWindow::excluded_data, CargoSpec::Index(), Window::SetDirty(), ToggleBit(), and Window::ToggleWidgetLoweredState().

virtual void PaymentRatesGraphWindow::OnInvalidateData | ( | int | data | ) | `[inline, virtual]`

Some data on this window has become invalid.

Parameters:

  | data | information about the changed data.

Reimplemented from BaseGraphWindow.

Definition at line 906 of file graph_gui.cpp.

References OnHundredthTick().

virtual void PaymentRatesGraphWindow::UpdateWidgetSize | ( | int | widget,
|  | Dimension * | size,
|  | const Dimension & | padding,
|  | Dimension * | fill,
|  | Dimension * | resize |
| ) |  |  | `[inline, virtual]`

Update size and resize step of a widget in the window.

After retrieval of the minimal size and the resize-steps of a widget, this function is called to allow further refinement, typically by computing the real maximal size of the content. Afterwards, size is taken to be the minimal size of the widget and resize is taken to contain the resize steps. For the convenience of the callee, padding contains the amount of padding between the content and the edge of the widget. This should be added to the returned size.

Parameters:

  | widget | Widget number.
  | size | Size of the widget.
  | padding | Recommended amount of space between the widget content and the widget edge.
  | fill | Fill step of the widget.
  | resize | Resize step of the widget.

Reimplemented from BaseGraphWindow.

Definition at line 842 of file graph_gui.cpp.

References CargoSpec::Get(), GetStringBoundingBox(), maxdim(), CargoSpec::name, SetDParam(), WD_FRAMERECT_BOTTOM, WD_FRAMERECT_LEFT, WD_FRAMERECT_RIGHT, and WD_FRAMERECT_TOP.

The documentation for this struct was generated from the following file:

- src/graph_gui.cpp